// Generated by gmmproc 2.46.1 -- DO NOT MODIFY!


#include <glibmm.h>

#include <libgdamm/transactionstatus.h>
#include <libgdamm/private/transactionstatus_p.h>


/* $Id: transactionstatus.ccg,v 1.2 2006/12/23 09:34:17 murrayc Exp $ */
// -*- C++ -*- // this is for the .ccg, I realize gensig puts one in

/* transactionstatus.cc
 * 
 * Copyright 2001      Free Software Foundation
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <libgda/gda-transaction-status.h>
#include <libgda/gda-enum-types.h>

namespace Gnome
{

namespace Gda
{

//We custom-implement this, copying stuff from the gda_transaction_status_new() implemenation:
TransactionStatus::TransactionStatus(const Glib::ustring& name)
:
  // Mark this class as non-derived to allow C++ vfuncs to be skipped.
  Glib::ObjectBase(0),
  Glib::Object(Glib::ConstructParams(transactionstatus_class_.init()))
{
  // Cannot use set_name because it just doesn't exist anymore. //TODO: Is it a property instead? File a bug with libgda if necessary. murrayc.
  if(!name.empty())
    gobj()->name = g_strdup(name.c_str());
}

} //namespace Gda


} /* namespace Gnome */


namespace
{
} // anonymous namespace

// static
GType Glib::Value<Gnome::Gda::TransactionIsolation>::value_type()
{
  return gda_transaction_isolation_get_type();
}


namespace Glib
{

Glib::RefPtr<Gnome::Gda::TransactionStatus> wrap(GdaTransactionStatus* object, bool take_copy)
{
  return Glib::RefPtr<Gnome::Gda::TransactionStatus>( dynamic_cast<Gnome::Gda::TransactionStatus*> (Glib::wrap_auto ((GObject*)(object), take_copy)) );
  //We use dynamic_cast<> in case of multiple inheritance.
}

} /* namespace Glib */


namespace Gnome
{

namespace Gda
{


/* The *_Class implementation: */

const Glib::Class& TransactionStatus_Class::init()
{
  if(!gtype_) // create the GType if necessary
  {
    // Glib::Class has to know the class init function to clone custom types.
    class_init_func_ = &TransactionStatus_Class::class_init_function;

    // This is actually just optimized away, apparently with no harm.
    // Make sure that the parent type has been created.
    //CppClassParent::CppObjectType::get_type();

    // Create the wrapper type, with the same class/instance size as the base type.
    register_derived_type(gda_transaction_status_get_type());

    // Add derived versions of interfaces, if the C type implements any interfaces:

  }

  return *this;
}


void TransactionStatus_Class::class_init_function(void* g_class, void* class_data)
{
  const auto klass = static_cast<BaseClassType*>(g_class);
  CppClassParent::class_init_function(klass, class_data);


}


Glib::ObjectBase* TransactionStatus_Class::wrap_new(GObject* object)
{
  return new TransactionStatus((GdaTransactionStatus*)object);
}


/* The implementation: */

GdaTransactionStatus* TransactionStatus::gobj_copy()
{
  reference();
  return gobj();
}

TransactionStatus::TransactionStatus(const Glib::ConstructParams& construct_params)
:
  Glib::Object(construct_params)
{

}

TransactionStatus::TransactionStatus(GdaTransactionStatus* castitem)
:
  Glib::Object((GObject*)(castitem))
{}


TransactionStatus::TransactionStatus(TransactionStatus&& src) noexcept
: Glib::Object(std::move(src))
{}

TransactionStatus& TransactionStatus::operator=(TransactionStatus&& src) noexcept
{
  Glib::Object::operator=(std::move(src));
  return *this;
}

TransactionStatus::~TransactionStatus() noexcept
{}


TransactionStatus::CppClassType TransactionStatus::transactionstatus_class_; // initialize static member

GType TransactionStatus::get_type()
{
  return transactionstatus_class_.init().get_type();
}


GType TransactionStatus::get_base_type()
{
  return gda_transaction_status_get_type();
}


Glib::RefPtr<TransactionStatus> TransactionStatus::create(const Glib::ustring& name)
{
  return Glib::RefPtr<TransactionStatus>( new TransactionStatus(name) );
}

 TransactionIsolation TransactionStatus::get_get_isolation_level() const
{
  return ((TransactionIsolation)(gobj()->isolation_level));
}
 
 Glib::ustring TransactionStatus::get_get_name() const
{
  return Glib::convert_const_gchar_ptr_to_ustring(gobj()->name);
}
 

} // namespace Gda

} // namespace Gnome


